#include <iostream>
#include <cmath>
using namespace std;
// The size of the array:
const int n=10;
// The class implements the Taylor series:
class Taylor{
private:
   // The field is an array:
   double a[n];
public:
   // The operator method for indexing objects:
   double &operator[](int k){
      return a[k];
   }
   // The constructor with a numerical argument:
   Taylor(double p=0){
      for(int k=0;k<n;k++){
         (*this)[k]=p; // Indexing the object
      }
   }
   // The constructor whose argument is a pointer:
   Taylor(double* b){
      for(int k=0;k<n;k++){
         (*this)[k]=b[k]; // Indexing the object
      }
   }
   // The operator method calculates
   // the series:
   double operator()(double x){
      double s=0,q=1;
      for(int k=0;k<n;k++){
         s+=(*this)[k]*q; // Indexing the object
         q*=x;
      }
      return s;
   }
};
// The main function of the program:
int main(){
   // The numerical array:
   double b[n]=
   {0,1,0,1./3,0,2./15,0,17./315,0,62./2835};
   // Creates objects:
   Taylor myexp,f(1),mytan(b);
   // Indexing the object:
   myexp[0]=1;
   // Fills the array that is the field of the object:
   for(int k=1;k<n;k++){
      myexp[k]=myexp[k-1]/k; // Indexing the object
   }
   // The argument:
   double x=1.0;
   // Calculates the series:
   cout<<myexp(x)<<" vs. "<<exp(x)<<endl;
   cout<<mytan(x)<<" vs. "<<tan(x)<<endl;
   cout<<f(x/2)<<" vs. "<<1/(1-x/2)<<endl;
   return 0;
}