#include <iostream>
using namespace std;
// The base template class:
template<class X> class BaseClass{
private:
   // The private field:
   X value;
public:
   // The constructor:
   BaseClass(X val){
      set(val);
   }
   // The method assigns a value to the field:
   void set(X val){
      value=val;
   }
   // The method gets the value of the field:
   X get(){
      return value;
   }
};
// The first derivative class:
class Alpha: public BaseClass<int>{
public:
   // The constructor:
   Alpha():BaseClass<int>(0){}
};
// The second derivative class:
class Bravo: public BaseClass<char>{
public:
   // The constructor:
   Bravo(char s):BaseClass<char>(s){}
};
// The main function of the program:
int main(){
   // An object of the first derivative class:
   Alpha objA;
   // Performs operations with the object:
   cout<<"The object objA: "<<objA.get()<<endl;
   objA.set(100);
   cout<<"The object objA: "<<objA.get()<<endl;
   // An object of the second derivative class:
   Bravo objB('A');
   // Performs operations with the object:
   cout<<"The object objB: "<<objB.get()<<endl;
   objB.set('B');
   cout<<"The object objB: "<<objB.get()<<endl;
   return 0;
}