#include <iostream>
#include <string>
#include <thread>
#include <chrono>
#include <mutex>
using namespace std;
mutex m;
// The function for creating the threads:
void mythread(string name,int time,int steps){
   for(int k=1;k<=steps;k++){
      // Time delay in the statement execution:
      this_thread::sleep_for(chrono::seconds(time));
      // Blocks access to the resource (console):
      m.lock();
      // Prints a message in the console:
      cout<<"The thread "<<name<<
      ":\tmessage "<<k<<endl;
      // Unblocks the resource (console):
      m.unlock();
   }
}
// The main function of the program:
int main(){
   // The number of loops in the threads:
   int n=5;
   cout<<"Running the threads...\n";
   // The first child thread:
   thread A(mythread,"Alpha",4,n);
   // The second child thread:
   thread B(mythread,"Bravo",3,n);
   // Calls the function in the main thread:
   mythread("Main",2,n);
   // Waits for the first thread termination:
   if(A.joinable()){
      A.join();
   }
   // Waits for the second thread termination:
   if(B.joinable()){
      B.join();
   }
   cout<<"The program is terminated\n";
   return 0;
}