#include <iostream>
using namespace std;
// The description of the function:
double phi(int k,double z,double* x,int n){
   // The index:
   int i;
   // The variable to save the result:
   double res=1;
   // Calculates the product:
   for(i=0;i<k;i++){
      res*=(z-x[i])/(x[k]-x[i]);
   }
   for(i=k+1;i<n;i++){
      res*=(z-x[i])/(x[k]-x[i]);
   }
   // The result of the function:
   return res;
}
// The polynomial of Lagrange:
double L(double z,double* x,double* y,int n){
   // The variable to save the result:
   double s=0;
   // Calculates the polynomial sum:
   for(int k=0;k<n;k++){
      s+=y[k]*phi(k,z,x,n);
   }
   // The result of the function:
   return s;
}
// The function prints the "line":
void line(int m){
   for(int k=1;k<=m;k++){
      cout<<"-";
   }
   cout<<endl;
}
// The main function of the program:
int main(){
   // The index and the length of the "line":
   int k,m=20;
   // The size of the array:
   const int n=5;
   // The points:
   double x[n]={1,3,5,7,9};
   // The values of the function:
   double y[n]={0,2,-1,1,3};
   line(m);
   cout<<"x\t| L(x)\n";
   line(m);
   // Prints the points and the values
   // of the interpolation polynomial:
   for(k=0;k<n;k++){
      cout<<x[k]<<"\t| "<<L(x[k],x,y,n)<<endl;
   }
   // The increment of the argument:
   double dx=1;
   line(m);
   cout<<"x\t| L(x)\n";
   line(m);
   // The values of the argument
   // and the values of the polynomial:
   for(k=0;k<n;k++){
      cout<<x[k]+dx<<"\t| "<<L(x[k]+dx,x,y,n)<<endl;
   }
   return 0;
}