#include <iostream>
#include <cmath>
using namespace std;
// The function calculates integrals
// by the Monte Carlo method:
double integrate(double (*f)(double),double a,
double b,double Fmax){
   // The variables to save the coordinates
   // of a point:
   double x,y;
   // The number of intervals for each axis:
   int m=10000;
   // The increment for the first coordinate:
   double dx=(b-a)/m;
   // The increment for the second coordinate:
   double dy=Fmax/m;
   // The variable to count the points:
   int count=0;
   // Iterates the points on the grid:
   for(int i=0;i<=m;i++){
      for(int j=0;j<=m;j++){
         // The first coordinate of the point:
         x=a+i*dx;
         // The second coordinate of the point:
         y=j*dy;
         // Tests the point:
         if(y<=f(x)){
            // If the point is under the graph:
            count++;
         }
      }
   }
   // The fraction of the points under the graph:
   double z=(double)count/(m+1)/(m+1);
   // The result of the function:
   return Fmax*(b-a)*z;
}
// The integrand functions:
double F1(double x){
   return x*(1-x);
}
double F2(double x){
   double pi=3.141592;
   return pi/2*tan(pi*x/4);
}
// The main function of the program:
int main(){
   cout<<"Calculation of integrals\n";
   cout<<integrate(F1,0,1,0.25)<<" vs. "<<
   (double)1/6<<endl;
   cout<<integrate(F2,0,1,1.6)<<" vs. "<<log(2)<<endl;
   return 0;
}